var myInput;
var mySpaceship;
var myRenderer;
var myBullets;
var myMeteors;
var myAliens;
var myPowerups;
var Field = {
	Width: 600, 
	Height: 600
};
var GameOver = false;
var Score = 0;
(function($) {
	$( document ).ready( function() {
		myInput = new Input();
		myBullets = [];
		myMeteors = [];
		myAliens = [];
		myPowerups = [];
		
		var $spaceship = $( '#spaceship' );
		var spaceshipArguments = {
			Position: {
				X: $spaceship.position().left,
				Y: $spaceship.position().top
			}
		};
		mySpaceship = new Spaceship( spaceshipArguments );
		myRenderer = new Renderer();
		$( '#main_wrapper' ).css({ 'width' : Field.Width+'px', 'height' : Field.Height+'px' });
		
		window.requestAnimationFrame( mainLoop );
	});
	var lastRender = 0;
	function mainLoop( timestamp ) {
		
		mySpaceship.update();
		myRenderer.update();
		
		for( var i=0; i < myBullets.length; i++ )
			myBullets[ i ].update();
		
		var randNewMeteor = Math.floor( ( Math.random() * 100 ) + 1 );
		if( randNewMeteor <= 2 ) {
			newMeteor();
		}
		for( var i=0; i < myMeteors.length; i++ )
			myMeteors[ i ].update();
		
		
		var randNewAlien = Math.floor( ( Math.random() * Math.max( 500, ( 3000 - Score*0.1 ) ) ) + 1 );
		if( randNewAlien <= 1 ) {
			newAlien();
		}
		for( var i=0; i < myAliens.length; i++ )
			myAliens[ i ].update();
		
		
		for( var i=0; i < myPowerups.length; i++ )
			myPowerups[ i ].update();
		
		var progress = timestamp - lastRender;
		lastRender = timestamp;
		window.requestAnimationFrame( mainLoop );
	}
	function newMeteor() {
		
		// Hier verwenden wir den gleichen Algorithmus wie beim Projektil
		var meteor_outof_area = false;
		for( var i=0; i < myMeteors.length; i++ )
			if( myMeteors[ i ].Position.Y >= Field.Height + 20 || myMeteors[ i ].Destroyed ) {
				myMeteors[ i ] = new Meteor({ ID: myMeteors[ i ].ID });
				meteor_outof_area = true;
				break;
			}
		if( !meteor_outof_area )
			myMeteors.push( new Meteor() );
		
	}
	function newPowerup( i ) {
		
		if( myMeteors[ i ].Type == "Big" ) {
			var randomSpawn = Math.floor( ( Math.random() * 100 ) + 1 );
			if( randomSpawn <= 30 ) {
				
				powerupArguments = {
					Position: {
						X: ( myMeteors[ i ].Position.X + myMeteors[ i ].Position.W/2 ) - 12.5,
						Y: ( myMeteors[ i ].Position.Y + myMeteors[ i ].Position.H/2 ) - 12.5
					},
					Speed: myMeteors[ i ].Speed,
					Direction: {
						X: myMeteors[ i ].Direction.X,
						Y: myMeteors[ i ].Direction.Y
					}
				};
				
				var powerup_outof_area = false;
				for( var i=0; i < myPowerups.length; i++ )
					if( myPowerups[ i ].Position.Y >= Field.Height + 20 || myPowerups[ i ].Destroyed ) {
						powerupArguments.ID = myPowerups[ i ].ID;
						myPowerups[ i ] = new Powerup( powerupArguments );
						powerup_outof_area = true;
						break;
					}
				if( !powerup_outof_area )
					myPowerups.push( new Powerup( powerupArguments ) );
				
			}
		}
		
	}
	function newAlien() {
		
		// Hier verwenden wir den gleichen Algorithmus wie beim Projektil
		var destroyed_aliens_exists = false;
		for( var i=0; i < myAliens.length; i++ )
			if( myAliens[ i ].Destroyed ) {
				myAliens[ i ] = new Alien({ ID: myAliens[ i ].ID });
				destroyed_aliens_exists = true;
				break;
			}
		if( !destroyed_aliens_exists )
			myAliens.push( new Alien() );
		
	}
	function checkCollision( a, b ) {
		
		return !(
			( ( a.Position.Y + a.Position.H ) < ( b.Position.Y ) ) ||
			( a.Position.Y > ( b.Position.Y + b.Position.H ) ) ||
			( ( a.Position.X + a.Position.W ) < b.Position.X ) ||
			( a.Position.X > ( b.Position.X + b.Position.W ) )
		);
		
	}
	
	
	class Input {
		constructor( args ) {
			args = args || {};
			
			this.Arrows = {};
			this.Arrows.Left = false;
			this.Arrows.Right = false;
			this.Arrows.Up = false;
			this.Arrows.Down = false;
			
			this.Space = false;
			
			this.init();
		}
		init() {
			this.trackInputs();
		}
		trackInputs() {
			var _this = this;
			$( document ).on( 'keydown', function( e ) {
				if( e.which == 37 ) _this.Arrows.Left = true;
				if( e.which == 39 ) _this.Arrows.Right = true;
				if( e.which == 38 ) _this.Arrows.Up = true;
				if( e.which == 40 ) _this.Arrows.Down = true;
				if( e.which == 32 ) _this.Space = true;
				
				if( $.inArray( e.which, [ 32, 37, 38, 39, 40 ] ) !== -1 ) 
					e.preventDefault();
			});
			$( document ).on( 'keyup', function( e ) {
				if( e.which == 37 ) _this.Arrows.Left = false;
				if( e.which == 39 ) _this.Arrows.Right = false;
				if( e.which == 38 ) _this.Arrows.Up = false;
				if( e.which == 40 ) _this.Arrows.Down = false;
				if( e.which == 32 ) _this.Space = false;
				
				if( $.inArray( e.which, [ 32, 37, 38, 39, 40 ] ) !== -1 )
					e.preventDefault();
			});
		}
	}
	class Renderer {
		constructor() {
			this.Spaceship = $( '#main_wrapper #spaceship' );
			this.Shield = $( '#main_wrapper #shield' );
		}
		
		update() {
			if( typeof this.Spaceship !== "undefined" ) {
				this.updateSpaceship();
				this.checkGameOver();
				this.checkLifes();
				this.changeScore();
			}
			if( typeof myBullets !== "undefined" && myBullets.length > 0 ) this.updateBullets();
			if( typeof myMeteors !== "undefined" && myMeteors.length > 0 ) this.updateMeteors();
			if( typeof myAliens !== "undefined" && myAliens.length > 0 ) this.updateAliens();
			if( typeof myPowerups !== "undefined" && myPowerups.length > 0 ) this.updatePowerups();
			if( typeof myBullets !== "undefined" && myBullets.length > 0
			||	typeof myMeteors !== "undefined" && myMeteors.length > 0
			||	typeof myAliens !== "undefined" && myAliens.length > 0 )
				this.checkDestroyed();
		}
		
		updateSpaceship() {
			
			this.Spaceship.css({ 'left' : mySpaceship.Position.X + 'px' });
			this.Spaceship.css({ 'top' : mySpaceship.Position.Y + 'px' });
			
			if( mySpaceship.DirectionH == 1 ) this.Spaceship.attr( 'data-direction', 'right' );
			else if( mySpaceship.DirectionH == -1 ) this.Spaceship.attr( 'data-direction', 'left' );
			else if( mySpaceship.DirectionH == 0 ) this.Spaceship.attr( 'data-direction', '' );
			
			if( this.Shield.length ) {
				var shield_active = false;
				for( var i=0; i < mySpaceship.PowerUps.length; i++ ) {
					if( mySpaceship.PowerUps[ i ].Type == "Shield" && mySpaceship.PowerUps[ i ].Duration > 0 ) {
						if( this.Shield.attr( 'data-active' ) != true )
							this.Shield.attr( 'data-active', true );
						shield_active = true;
						break;
					}
				}
				if( !shield_active && this.Shield.attr( 'data-active' ) != false ) {
					this.Shield.attr( 'data-active', false );
				}
				this.Shield.css({
					'left' : mySpaceship.Position.X + 'px',
					'top' : mySpaceship.Position.Y + 'px'
				});
			}
			else {
				$( '#main_wrapper' ).append( '<div id="shield"></div>' );
				this.Shield = $( '#main_wrapper #shield' );
			}
			
		}
		
		updateBullets() {
			
			for( var i=0; i < myBullets.length; i++ ) {
				var $Bullet = $( '#bullet_'+myBullets[ i ].ID );
				if( $Bullet.length ) {
					if( myBullets[ i ].Position.Y >= -200 ) {
						$Bullet.css({ 
							'top' : myBullets[ i ].Position.Y+'px',
							'left' : myBullets[ i ].Position.X+'px'
						});
						if( myBullets[ i ].PowerupShot == false && $Bullet.attr( 'data-powerup' ) != false ) 
							$Bullet.attr( 'data-powerup', false );
						else if( myBullets[ i ].PowerupShot == true && $Bullet.attr( 'data-powerup' ) != true ) 
							$Bullet.attr( 'data-powerup', true );
					}
				}
				else {
					$( '#main_wrapper' ).append( '<div id="bullet_'+myBullets[ i ].ID+'" class="bullet" data-powerup="'+myBullets[ i ].PowerupShot+'" data-type="'+myBullets[ i ].Type.toLowerCase()+'" style="left: '+( myBullets[ i ].Position.X - 1 )+'px; top: '+( myBullets[ i ].Position.Y - 18 )+'px;"></div>' );
				}
			}
			
		}
		
		updateMeteors() {
			
			for( var i=0; i < myMeteors.length; i++ ) {
				var $Meteor = $( '#meteor_'+myMeteors[ i ].ID );
				if( $Meteor.length ) {
					if( myMeteors[ i ].Position.Y <= Field.Height + 50 ) {
						$Meteor.css({ 
							'top' : myMeteors[ i ].Position.Y+'px',
							'left' : myMeteors[ i ].Position.X+'px'
						});
						if( myMeteors[ i ].Type.toLowerCase() !== $Meteor.attr( 'data-type' ) )
							$Meteor.attr( 'data-type', myMeteors[ i ].Type.toLowerCase() );
					}
				}
				else {
					$( '#main_wrapper' ).append( '<div id="meteor_'+myMeteors[ i ].ID+'" class="meteor" data-type="'+myMeteors[ i ].Type.toLowerCase()+'" style="left: '+( myMeteors[ i ].Position.X )+'px; top: '+( myMeteors[ i ].Position.Y )+'px;"></div>' );
				}
			}
			
		}
		
		updateAliens() {
			
			for( var i=0; i < myAliens.length; i++ ) {
				var $Alien = $( '#alien_'+myAliens[ i ].ID );
				if( $Alien.length ) {
					if( myAliens[ i ].Position.Y <= Field.Height + 50 ) {
						$Alien.css({ 
							'top' : myAliens[ i ].Position.Y+'px',
							'left' : myAliens[ i ].Position.X+'px'
						});
					}
				}
				else {
					$( '#main_wrapper' ).append( '<div id="alien_'+myAliens[ i ].ID+'" class="alien" style="left: '+( myAliens[ i ].Position.X )+'px; top: '+( myAliens[ i ].Position.Y )+'px;"></div>' );
				}
			}
			
		}
		
		updatePowerups() {
			
			for( var i=0; i < myPowerups.length; i++ ) {
				var $Powerup = $( '#powerup_'+myPowerups[ i ].ID );
				if( $Powerup.length ) {
					if( myPowerups[ i ].Position.Y <= Field.Height + 50 ) {
						$Powerup.css({ 
							'top' : myPowerups[ i ].Position.Y+'px',
							'left' : myPowerups[ i ].Position.X+'px'
						});
						if( myPowerups[ i ].Type.toLowerCase() !== $Powerup.attr( 'data-type' ) )
							$Powerup.attr( 'data-type', myPowerups[ i ].Type.toLowerCase() );
					}
				}
				else {
					$( '#main_wrapper' ).append( '<div id="powerup_'+myPowerups[ i ].ID+'" class="powerup" data-type="'+myPowerups[ i ].Type.toLowerCase()+'" style="left: '+( myPowerups[ i ].Position.X )+'px; top: '+( myPowerups[ i ].Position.Y )+'px;"></div>' );
				}
			}
			
		}
		
		checkDestroyed() {
			
			for( var i=0; i < myBullets.length; i++ )
				if( typeof myBullets[ i ] !== "undefined" )
					if( typeof myBullets[ i ].Destroyed !== "undefined" && myBullets[ i ].Destroyed == true )
						$( '#bullet_'+myBullets[ i ].ID ).attr( 'data-destroyed', 'true' );
					else if( typeof myBullets[ i ].Destroyed !== "undefined" && myBullets[ i ].Destroyed == false )
						$( '#bullet_'+myBullets[ i ].ID ).attr( 'data-destroyed', 'false' );
			
			for( var i=0; i < myMeteors.length; i++ )
				if( typeof myMeteors[ i ] !== "undefined" )
					if( typeof myMeteors[ i ].Destroyed !== "undefined" && myMeteors[ i ].Destroyed == true )
						$( '#meteor_'+myMeteors[ i ].ID ).attr( 'data-destroyed', 'true' );
					else if( typeof myMeteors[ i ].Destroyed !== "undefined" && myMeteors[ i ].Destroyed == false )
						$( '#meteor_'+myMeteors[ i ].ID ).attr( 'data-destroyed', 'false' );
			
			for( var i=0; i < myAliens.length; i++ )
				if( typeof myAliens[ i ] !== "undefined" )
					if( typeof myAliens[ i ].Destroyed !== "undefined" && myAliens[ i ].Destroyed == true )
						$( '#alien_'+myAliens[ i ].ID ).attr( 'data-destroyed', 'true' );
					else if( typeof myAliens[ i ].Destroyed !== "undefined" && myAliens[ i ].Destroyed == false )
						$( '#alien_'+myAliens[ i ].ID ).attr( 'data-destroyed', 'false' );
			
			for( var i=0; i < myPowerups.length; i++ )
				if( typeof myPowerups[ i ] !== "undefined" )
					if( typeof myPowerups[ i ].Destroyed !== "undefined" && myPowerups[ i ].Destroyed == true )
						$( '#powerup_'+myPowerups[ i ].ID ).attr( 'data-destroyed', 'true' );
					else if( typeof myPowerups[ i ].Destroyed !== "undefined" && myPowerups[ i ].Destroyed == false )
						$( '#powerup_'+myPowerups[ i ].ID ).attr( 'data-destroyed', 'false' );
			
		}
		
		checkGameOver() {
			
			if( GameOver )
				if( $( '#spaceship' ).length ) {
					this.Spaceship.remove();
					$( '#main_wrapper' ).append( '<div id="gameover" style="padding: '+( Field.Height/2 + 50/2 )+'">GameOver<br/><span class="score">Score: '+Score+'</span></div>' );
				}
			
		}
		
		checkLifes() {
			
			var spaceshipLifes = mySpaceship.Life;
			var currentGUILifes = $( '#main_wrapper .life' ).length;
			if( spaceshipLifes != currentGUILifes ) {
				$( '#main_wrapper .life' ).remove();
				for( var i=0; i < spaceshipLifes; i++ ) {
					$( '#main_wrapper' ).append( '<div class="life" style="left: '+( i*30+10 )+'px;"></div>' );
				}
			}
			
		}
		
		changeScore() {
			
			var $Score = $( '#main_wrapper #score' );
			if( $Score.length ) {
				if( $Score.html() !== Score )
					$Score.html( Score );
			}
			else {
				$( '#main_wrapper' ).append( '<div id="score">'+Score+'</div>' );
			}
			
		}
		
	}
	
	class Spaceship {
		constructor( args ) {
			args = args || {};
			
			this.Position = { X: 0, Y: 0, W: 49.5, H: 37.5 };
			if( typeof args.Position !== "undefined" ) {
				if( typeof args.Position.X !== "undefined" )
					this.Position.X = args.Position.X;
				if( typeof args.Position.Y !== "undefined" )
					this.Position.Y = args.Position.Y;
				if( typeof args.Position.W !== "undefined" )
					this.Position.W = args.Position.W;
				if( typeof args.Position.H !== "undefined" )
					this.Position.H = args.Position.H;
			}
			this.DirectionH = 0;
			
			if( typeof args.Life !== "undefined" )
				this.Life = args.Life; 
			else this.Life = 5;
			
			if( typeof args.Speed !== "undefined" )
				this.Speed = args.Speed;
			else this.Speed = 5;
			
			if( typeof args.Damage !== "undefined" )
				this.Damage = args.Damage;
			else this.Damage = 1;
			
			// Wir fügen noch einen Timer hinzu, der nur nach einer kurzer Abklingzeit einen Schuss abfeuern soll
			this.shootTimer = 0;
			
			this.PowerUps = [];
		}
		update() {
			if( !GameOver ) {
				if( typeof myInput !== "undefined" ) {
					this.move();
					this.shoot();
					this.collision();
				}
				// Hier wird der Timer heruntergezählt, bis er "0" erreicht hat
				if( this.shootTimer > 0 ) this.shootTimer--;
				
				for( var i=0; i < this.PowerUps.length; i++ ) {
					if( this.PowerUps[ i ].Duration > 0 )
						this.PowerUps[ i ].Duration -= 1;
				}
			}
		}
		move() {
			if( this.Position.X < 0 ) this.Position.X = 0;
			if( this.Position.X + this.Position.W > Field.Width ) this.Position.X = Field.Width - this.Position.W;
			if( this.Position.Y < 0 ) this.Position.Y = 0;
			if( this.Position.Y + this.Position.H > Field.Height ) this.Position.Y = Field.Height - this.Position.H;
			
			if( myInput.Arrows.Left && !myInput.Arrows.Right ) {
				if( this.Position.X > 0 ) this.Position.X -= this.Speed;
				this.DirectionH = -1;
			}
			else if( myInput.Arrows.Right && !myInput.Arrows.Left ) {
				this.Position.X += this.Speed;
				this.DirectionH = 1;
			}
			else {
				this.DirectionH = 0;
			}
			
			if( myInput.Arrows.Up && !myInput.Arrows.Down ) {
				this.Position.Y -= this.Speed;
			}
			else if( myInput.Arrows.Down && !myInput.Arrows.Up ) {
				this.Position.Y += this.Speed;
			}
		}
		shoot() {
			if( myInput.Space ) {
				// Sobald der Timer "0" erreicht hat und die Leertaste betätigt wurde beginnt der Algorithmus, um ein neues Projektil zu erstellen
				if( this.shootTimer <= 0 ) {
					
					// Hier bereiten wir die initiale Position des Projektils vor
					var bulletPosition = {
						X: this.Position.X + this.Position.W / 2,
						Y: this.Position.Y
					};
					
					// Damit das Programm nicht ständig die Projektile löschen und wieder platzieren muss fragen wir an dieser Stelle ab, ob ein Projektil außerhalb des sichtbaren Bereichs liegt und ersetzen diesen, falls dies der Fall sein sollte
					var bullet_on_negative = false;
					for( var i=0; i < myBullets.length; i++ )
						if( myBullets[ i ].Position.Y < -20 ) {
							$( '#bullet_'+myBullets[ i ].ID ).remove();
							myBullets[ i ] = new Bullet({ ID: i, Position: bulletPosition });
							bullet_on_negative = true;
							break;
						}
					
					// Falls mehr Projektile benötigt werden, als bereits auf dem Spielfeld platziert wurden wird an dieser Stelle ein neuer hinzugefügt
					if( !bullet_on_negative )
						myBullets.push( new Bullet({ Position: bulletPosition }) );
					
					var speedMultiplier = 1;
					for( var i=0; i < this.PowerUps.length; i++ ) {
						if( this.PowerUps[ i ].Type == "Speed" ) {
							if( this.PowerUps[ i ].Duration > 0 )
								speedMultiplier *= this.PowerUps[ i ].Multiplier;
						}
					}
					if( speedMultiplier >= 1 )
						this.shootTimer = 32 / speedMultiplier;
					if( this.shootTimer < 5 )
						this.shootTimer = 5;
					
				}
			}
		}
		collision() {
			
			for( var i=0; i < myMeteors.length; i++ )
				if( !myMeteors[ i ].Destroyed )
					if( checkCollision( this, myMeteors[ i ] ) ) {
						
						var shield_exists = false;
						for( var j=0; j < this.PowerUps.length; j++ ) 
							if( this.PowerUps[ j ].Type == "Shield" && this.PowerUps[ j ].Duration > 0 ) {
								this.PowerUps[ j ].Duration = 0;
								shield_exists = true;
								break;
							}
						
						if( !shield_exists ) {
							this.Life -= 1;
							if( this.Life <= 0 )
								GameOver = true;
						}
						
						myMeteors[ i ].Life = 0;
						myMeteors[ i ].Destroyed = true;
						
					}
			
			for( var i=0; i < myBullets.length; i++ )
				if( myBullets[ i ].Type == "Alien" )
				if( !myBullets[ i ].Destroyed )
					if( checkCollision( this, myBullets[ i ] ) ) {
						
						var shield_exists = false;
						for( var j=0; j < this.PowerUps.length; j++ ) 
							if( this.PowerUps[ j ].Type == "Shield" && this.PowerUps[ j ].Duration > 0 ) {
								this.PowerUps[ j ].Duration = 0;
								shield_exists = true;
								break;
							}
						
						if( !shield_exists ) {
							this.Life -= myBullets[ i ].Damage;
							if( this.Life <= 0 )
								GameOver = true;
						}
						
						myBullets[ i ].Life = 0;
						myBullets[ i ].Destroyed = true;
						
					}
			
			for( var i=0; i < myPowerups.length; i++ )
				if( !myPowerups[ i ].Destroyed )
					if( checkCollision( this, myPowerups[ i ] ) ) {
						
						myPowerups[ i ].Destroyed = true;
						var powerupArguments = {
							Type: myPowerups[ i ].Type,
							Multiplier: myPowerups[ i ].Multiplier,
							Duration: myPowerups[ i ].Duration
						};
						var empty_powerups = false;
						for( var i=0; i < this.PowerUps.length; i++ ) {
							if( this.PowerUps[ i ].Duration <= 0 ) {
								this.PowerUps[ i ] = powerupArguments;
								empty_powerups = true;
								break;
							}
						}
						if( !empty_powerups )
							this.PowerUps.push( powerupArguments );
						
					}
			
		}
		
	}
	
	class Alien {
		constructor( args ) {
			args = args || {};
			
			this.Destroyed = false;
			
			if( typeof args.ID !== "undefined" )
				this.ID = args.ID;
			else
				this.ID = myAliens.length;
			
			this.Position = { X: 0, Y: -30, W: 49, H: 25 };
			if( typeof args.Position !== "undefined" ) {
				if( typeof args.Position.X !== "undefined" )
					this.Position.X = args.Position.X;
				if( typeof args.Position.Y !== "undefined" )
					this.Position.Y = args.Position.Y;
				if( typeof args.Position.W !== "undefined" )
					this.Position.W = args.Position.W;
				if( typeof args.Position.H !== "undefined" )
					this.Position.H = args.Position.H;
			}
			if( this.Position.X == 0 ) {
				var randomPositionX = Math.floor( ( Math.random() * Field.Width ) + 1 );
				this.Position.X = randomPositionX;
			}
			
			this.DirectionH = 0;
			
			if( typeof args.Life !== "undefined" )
				this.Life = args.Life;
			else
				this.Life = Math.floor( ( Math.random() * 15 ) + 5 );
			
			if( typeof args.Speed !== "undefined" )
				this.Speed = args.Speed;
			else
				this.Speed = Math.floor( ( Math.random() * 3 ) + 3 );
			
			if( typeof args.Damage !== "undefined" )
				this.Damage = args.Damage;
			else
				this.Damage = 1;
			
			if( typeof args.maxShootTimer !== "undefined" )
				this.maxShootTimer = args.maxShootTimer;
			else 
				this.maxShootTimer = Math.floor( ( Math.random() * 90 ) + 30 );
			this.shootTimer = 0;
			
			var randomPositionY = Math.floor( ( Math.random() * Field.Height/2 ) + 1 );
			this.YLine = randomPositionY;
			
			this.Status = "Follow";
		}
		
		update() {
			
			if( !GameOver && !this.Destroyed ) {
				this.move();
				this.shoot();
				if( this.shootTimer > 0 ) this.shootTimer--;
				
				
				var randomChangeY = Math.floor( ( Math.random() * 100 ) + 1 );
				if( randomChangeY <= 1 ) {
					var randomPositionY = Math.floor( ( Math.random() * Field.Height/2 ) + 1 );
					this.YLine = randomPositionY;
				}
				
				var maxRand = 2000;
				if( this.Status == "Follow" ) maxRand = 3000;
				var randomChangeStatus = Math.floor( ( Math.random() * maxRand ) + 1 );
				if( randomChangeStatus <= 5 ) {
					if( this.Status == "Escape" ) this.Status = "Follow";
					else if( this.Status == "Follow" ) this.Status = "Escape";
				}
				
			}
			
		}
		move() {
			
			if( ( this.Status == "Follow" && ( mySpaceship.Position.X ) > ( this.Position.X + this.Position.W/2 ) ) 
			||	( this.Status == "Escape" && ( mySpaceship.Position.X + mySpaceship.Position.W/2 ) < ( this.Position.X + this.Position.W/2 ) ) ) {
				if( this.Position.X + this.Position.W < Field.Width ) 
					this.Position.X += this.Speed;
			}
			else if( ( this.Status == "Follow" && ( mySpaceship.Position.X + mySpaceship.Position.W ) < ( this.Position.X + this.Position.W/2 ) ) 
			||		 ( this.Status == "Escape" && ( mySpaceship.Position.X + mySpaceship.Position.W/2 ) > ( this.Position.X + this.Position.W/2 ) ) ) {
				if( this.Position.X > 0 )
					this.Position.X -= this.Speed;
			}
			
			if( this.Position.Y + 5 < this.YLine ) {
				this.Position.Y += this.Speed;
			}
			else if( this.Position.Y - 5 > this.YLine ) {
				this.Position.Y -= this.Speed;
			}
			
		}
		shoot() {
			
			var randomShoot = Math.floor( ( Math.random() * 100 ) + 1 );
			if( randomShoot <= 5 ) {
				if( this.shootTimer <= 0 ) {
					
					var bulletPosition = {
						X: this.Position.X + this.Position.W / 2,
						Y: this.Position.Y + this.Position.H
					};
					
					var bullet_on_negative = false;
					for( var i=0; i < myBullets.length; i++ )
						if( myBullets[ i ].Position.Y < -20 ) {
							$( '#bullet_'+myBullets[ i ].ID ).remove();
							myBullets[ i ] = new Bullet({ ID: i, Type: "Alien", Position: bulletPosition });
							bullet_on_negative = true;
							break;
						}
					
					if( !bullet_on_negative )
						myBullets.push( new Bullet({ Type: "Alien", Position: bulletPosition }) );
					
					this.shootTimer = this.maxShootTimer;
					
				}
			}
			
		}
		
	}
	
	class Bullet {
		constructor( args ) {
			args = args || {};
			
			this.Destroyed = false;
			this.PowerupShot = false;
			
			// Die ID des Projektils, um gleich die Bewegung des HTML-Tags zu steuern
			if( typeof args.ID !== "undefined" )
				this.ID = args.ID;
			else
				this.ID = myBullets.length;
			
			// Wird später wichtig, sobald die Alien-Schiffe implementiert werden
			if( typeof args.Type !== "undefined" ) this.Type = args.Type;
			else this.Type = 'Player';
			
			// Der Schaden, der verursacht wird, wenn das Projektil auf einen Gegner oder einen Meteoriten trifft
			if( typeof args.Damage !== "undefined" ) this.Damage = args.Damage;
			else if( this.Type == "Player" ) {
				this.Damage = 1;
				var damageMultiplier = 1;
				for( var i=0; i < mySpaceship.PowerUps.length; i++ ) {
					if( mySpaceship.PowerUps[i].Duration > 0 && mySpaceship.PowerUps[i].Type == "Power" )
						damageMultiplier += mySpaceship.PowerUps[i].Multiplier;
				}
				if( damageMultiplier > 1 ) {
					this.Damage *= damageMultiplier;
					this.PowerupShot = true;
				}
			}
			else 
				this.Damage = 1;
			
			// Die Geschwindigkeit in Pixel
			if( typeof args.Speed !== "undefined" ) this.Speed = args.Speed;
			else this.Speed = 7;
			
			// Die Position des Projektils
			this.Position = { X: -100, Y: -100, W: 4.5, H: 16.5 };
			if( typeof args.Position !== "undefined" ) {
				if( typeof args.Position.X !== "undefined" )
					this.Position.X = args.Position.X;
				if( typeof args.Position.Y !== "undefined" )
					this.Position.Y = args.Position.Y;
				if( typeof args.Position.W !== "undefined" )
					this.Position.W = args.Position.W;
				if( typeof args.Position.H !== "undefined" )
					this.Position.H = args.Position.H;
			}
			
			// Hier wird das Projektil zum Main-Wrapper hinzugefügt. Zudem wird eine initiale Animation gesetzt, die nach einer Sekunde entfernt wird. Den Fading-Effekt haben wir bereits in der CSS-Formatierung gesetzt, dadurch bekommen wir eine bessere Performance, als z.B. durch eine jQuery-Animation
			if( this.Position.X != -100 && this.Position.Y != -100 ) {
				if( this.Type == "Player" ) {
					$( '#main_wrapper' ).append( '<div class="bullet_shot" data-powerup="'+this.PowerupShot+'" data-type="'+this.Type.toLowerCase()+'" style="left: '+( this.Position.X - 13 )+'px; top: '+( this.Position.Y - 13 )+'px;"></div>' );
					$( '#main_wrapper .bullet_shot:last-of-type' ).delay( 1000 ).queue( function() { $(this).remove(); } );
				}
				else if( this.Type == "Alien" ) {
					$( '#main_wrapper' ).append( '<div class="bullet_shot" data-powerup="'+this.PowerupShot+'" data-type="'+this.Type.toLowerCase()+'" style="left: '+( this.Position.X - 13 )+'px; top: '+( this.Position.Y - 13 )+'px;"></div>' );
					$( '#main_wrapper .bullet_shot:last-of-type' ).delay( 1000 ).queue( function() { $(this).remove(); } );
				}
			}
			
		}
		
		update() {
			this.move();
			this.collision();
		}
		move() {
			
			// Hier wird die Bewegungsgeschwindigkeit zur Position abgezogen, da das Projektil nach oben geschossen wird
			if( this.Type == "Player" ) this.Position.Y -= this.Speed;
			else if( this.Type == "Alien" ) this.Position.Y += this.Speed;
			
		}
		collision() {
			
			if( !this.Destroyed ) {
				for( var i=0; i < myMeteors.length; i++ )
					if( this.Type == "Player" )
						if( !myMeteors[ i ].Destroyed )
							if( checkCollision( this, myMeteors[ i ] ) ) {
								myBullets[ this.ID ].Destroyed = true;
								
								myMeteors[ i ].Life -= this.Damage;
								if( myMeteors[ i ].Life <= 0 ) {
									if( myMeteors[ i ].Type == "Big" )
										Score += 100;
									else 
										Score += 25;
									
									myMeteors[ i ].Destroyed = true;
									newPowerup( i );
								}
								
							}
				
				for( var i=0; i < myAliens.length; i++ )
					if( this.Type == "Player" )
						if( !myAliens[ i ].Destroyed )
							if( checkCollision( this, myAliens[ i ] ) ) {
								myBullets[ this.ID ].Destroyed = true;
								
								myAliens[ i ].Life -= this.Damage;
								if( myAliens[ i ].Life <= 0 ) {
									Score += 250;
									myAliens[ i ].Destroyed = true;
								}
								
							}
				
			}
			
		}
		
	}
	
	class Meteor {
		constructor( args ) {
			args = args || {};
			
			this.Destroyed = false;
			
			// Die ID des Meteors, um die Bewegung des HTML-Tags zu steuern
			if( typeof args.ID !== "undefined" )
				this.ID = args.ID;
			else
				this.ID = myMeteors.length;
			
			// Die initiale Position des Meteors kann mit der übergabe des Parameters "Position" gesetzt werden
			this.Position = { X: 0, Y: 0, H: 0, W: 0 };
			if( typeof args.Position !== "undefined" ) {
				if( typeof args.Position.X !== "undefined" )
					this.Position.X = args.Position.X;
				if( typeof args.Position.Y !== "undefined" )
					this.Position.Y = args.Position.Y;
			}
			
			// Sollte die Position nicht gesetzt sein wird ein zufälliger Wert im oberen Bereich gewählt
			if( this.Position.X == 0 && this.Position.Y == 0 ) {
				var randomPositionX = Math.floor( ( Math.random() * Field.Width ) + 1 );
				this.Position.X = randomPositionX;
				this.Position.Y = -120;
			}
			
			// Über die Parameter des Konstruktors können wir übergeben, ob der Meteor klein oder groß sein soll. Sollte der Parameter nicht gesetzt sein wird ein kleiner Meteor erstellt
			if( typeof args.Type !== "undefined" )
				this.Type = args.Type;
			else {
				// Die Größe des Meteors soll zufällig erstellt werden
				var randMeteorType = Math.floor( ( Math.random() * 10 ) + 1 );
				if( randMeteorType >= 8 ) this.Type = "Big";
				else this.Type = "Small";
			}
			
			// Hier werden verschiedene größenspezifische Werte gesetzt, wie die Pixelgröße des Meteors, das Leben und die Gewschwindigkeit
			if( this.Type == "Small" ) {
				this.Life = 1;
				this.Speed = 2;
				
				this.Position.W = 44;
				this.Position.H = 42;
			}
			else if( this.Type == "Big" ) {
				this.Life = 3;
				this.Speed = 1;
				
				this.Position.W = 68;
				this.Position.H = 55.5;
			}
			
			// Hier geben wir eine Richtung vor, in die der Meteor fliegen soll. Die Y-Koordinate sollte immer Positiv sein, da der Meteor von oben nach unten fliegt
			this.Direction = { X: 0, Y: 0 };
			if( typeof args.Direction !== "undefined" ) {
				if( typeof args.Direction.X !== "undefined" )
					this.Direction.X = args.Direction.X;
				if( typeof args.Direction.Y !== "undefined" )
					this.Direction.Y = args.Direction.Y;
			}
			
			// Falls die Richtung nicht gesetzt sein sollte, oder die Y-Koordinate in die falsche Richtung zeigt, in die sich der Meteor bewegen soll, wird ein zufälliger Wert ermittelt
			if( this.Direction.X == 0 || this.Direction.Y <= 0 ) {
				
				var positionX = 0.5;
				if( this.Position.X - this.Position.W/2 > Field.Width/2 )
					positionX = -0.5;
				
				this.Direction.Y = 1;
				this.Direction.X = positionX;
				
			}
			
		}
		update() {
			this.move();
		}
		move() {
			
			// Um den Meteor zu steuern verwenden wir die Richtung Mal die Geschwindigkeit des Meteors und addieren den Wert aus der Multiplikation mit der aktuellen Position
			this.Position.X += this.Direction.X * this.Speed;
			this.Position.Y += this.Direction.Y * this.Speed;
			
		}
	}
	
	class Powerup {
		constructor( args ) {
			args = args || {};
			
			this.Destroyed = false;
			
			if( typeof args.ID !== "undefined" )
				this.ID = args.ID;
			else
				this.ID = myPowerups.length;
			
			if( typeof args.Type !== "undefined" )
				this.Type = args.Type;
			else {
				var randomType = Math.floor( ( Math.random() * 3 ) + 1 );
				switch( randomType ) {
					case 1: this.Type = "Speed"; break;
					case 2: this.Type = "Power"; break;
					case 3: this.Type = "Shield"; break;
					default: this.Type = "Speed"; break;
				}
			}
			
			if( typeof args.Duration !== "undefined" )
				this.Duration = args.Duration;
			else 
				this.Duration = 1000;
			
			if( typeof args.Multiplier !== "undefined" )
				this.Multiplier = args.Multiplier;
			else 
				this.Multiplier = 2.0;
			
			
			this.Position = { X: 0, Y: 0, H: 25, W: 25 };
			if( typeof args.Position !== "undefined" ) {
				if( typeof args.Position.X !== "undefined" )
					this.Position.X = args.Position.X;
				if( typeof args.Position.Y !== "undefined" )
					this.Position.Y = args.Position.Y;
			}
			
			this.Direction = { X: 0, Y: 0 };
			if( typeof args.Direction !== "undefined" ) {
				if( typeof args.Direction.X !== "undefined" )
					this.Direction.X = args.Direction.X;
				if( typeof args.Direction.Y !== "undefined" )
					this.Direction.Y = args.Direction.Y;
			}
			
			if( typeof args.Speed !== "undefined" )
				this.Speed = args.Speed;
			else
				this.Speed = 2;
		}
		update() {
			this.move();
		}
		move() {
			
			// Um den Meteor zu steuern verwenden wir die Richtung Mal die Geschwindigkeit des Meteors und addieren den Wert aus der Multiplikation mit der aktuellen Position
			this.Position.X += this.Direction.X * this.Speed;
			this.Position.Y += this.Direction.Y * this.Speed;
			
		}
	}
	
})(jQuery);